
#include "it.h"
#include "main.h"
#include "setup.h"
#include "stm32g4xx_hal.h"

// alternative: use idle itnerrupt that is fired if Receive happend but is waiting for rest of the
// bytes \o/ hint:
// https://github.com/SteelPh0enix/STM32_HM10_Driver/blob/master/Drivers/HM-10/hm10.cpp#L55
// https://github.com/SteelPh0enix/STM32_HM10_Driver/blob/master/Core/Src/freertos.cpp#L247

using namespace schpin;

perif_handlers HANDLERS;

uint8_t bc_in;
uint8_t bc_out;
uint8_t cb_in;
uint8_t cb_out;

int main()
{
        HANDLERS = setup_system();

        HAL_UART_RegisterCallback(
            &HANDLERS.bus_uart, HAL_UART_TX_COMPLETE_CB_ID, []( UART_HandleTypeDef* ) {} );
        HAL_UART_RegisterCallback(
            &HANDLERS.bus_uart, HAL_UART_RX_COMPLETE_CB_ID, []( UART_HandleTypeDef* ) {
                    bc_out = bc_in;
                    HAL_UART_Transmit_IT( &HANDLERS.bus_uart, &bc_out, 1 );
                    HAL_UART_Receive_IT( &HANDLERS.bus_uart, &bc_in, 1 );
            } );

        HAL_UART_RegisterCallback(
            &HANDLERS.com_uart, HAL_UART_TX_COMPLETE_CB_ID, []( UART_HandleTypeDef* ) {} );
        HAL_UART_RegisterCallback(
            &HANDLERS.com_uart, HAL_UART_RX_COMPLETE_CB_ID, []( UART_HandleTypeDef* ) {
                    cb_out = cb_in;
                    HAL_UART_Transmit_IT( &HANDLERS.bus_uart, &cb_out, 1 );
                    HAL_UART_Receive_IT( &HANDLERS.com_uart, &cb_in, 1 );
            } );

        HAL_UART_Receive_IT( &HANDLERS.com_uart, &cb_in, 1 );
        HAL_UART_Receive_IT( &HANDLERS.bus_uart, &bc_in, 1 );
        while ( true ) {
                asm( "nop" );
        }
}
