#include "it.h"

#include "main.h"

/**
 * @brief This function handles Non maskable interrupt.
 */
extern "C" void NMI_Handler( void )
{
}

/**
 * @brief This function handles Hard fault interrupt.
 */
extern "C" void HardFault_Handler( void )
{
        while ( 1 ) {
                asm( "nop" );
        }
}

/**
 * @brief This function handles Memory management fault.
 */
extern "C" void MemManage_Handler( void )
{
        while ( 1 ) {
                asm( "nop" );
        }
}

/**
 * @brief This function handles Prefetch fault, memory access fault.
 */
extern "C" void BusFault_Handler( void )
{
        while ( 1 ) {
                asm( "nop" );
        }
}

/**
 * @brief This function handles Undefined instruction or illegal state.
 */
extern "C" void UsageFault_Handler( void )
{
        while ( 1 ) {
                asm( "nop" );
        }
}

/**
 * @brief This function handles System service call via SWI instruction.
 */
extern "C" void SVC_Handler( void )
{
}

/**
 * @brief This function handles Debug monitor.
 */
extern "C" void DebugMon_Handler( void )
{
}

/**
 * @brief This function handles Pendable request for system service.
 */
extern "C" void PendSV_Handler( void )
{
}

/**
 * @brief This function handles System tick timer.
 */
extern "C" void SysTick_Handler( void )
{
        HAL_IncTick();
}

/**
 * @brief This function handles ADC1 and ADC2 global interrupt.
 */
extern "C" void ADC1_2_IRQHandler( void )
{
}

/**
 * @brief This function handles FDCAN1 interrupt 0.
 */
extern "C" void FDCAN1_IT0_IRQHandler( void )
{
        // HAL_FDCAN_IRQHandler( &hfdcan1 );
}

/**
 * @brief This function handles FDCAN1 interrupt 1.
 */
extern "C" void FDCAN1_IT1_IRQHandler( void )
{
        // HAL_FDCAN_IRQHandler( &hfdcan1 );
}

/**
 * @brief This function handles SPI1 global interrupt.
 */
extern "C" void SPI1_IRQHandler( void )
{
        // HAL_SPI_IRQHandler( &hspi1 );
}

/**
 * @brief This function handles USART1 global interrupt / USART1 wake-up interrupt through EXTI
 * line 25.
 */
extern "C" void USART1_IRQHandler( void )
{
        HAL_UART_IRQHandler( &HANDLERS.com_uart );
}

/**
 * @brief This function handles USART2 global interrupt / USART2 wake-up interrupt through EXTI
 * line 26.
 */
extern "C" void USART2_IRQHandler( void )
{
        HAL_UART_IRQHandler( &HANDLERS.bus_uart );
}

/**
 * @brief This function handles I2C3 event interrupt / I2C3 wake-up interrupt through EXTI line 27.
 */
extern "C" void I2C3_EV_IRQHandler( void )
{
        HAL_I2C_EV_IRQHandler( &HANDLERS.i2c );
}

/**
 * @brief This function handles I2C3 error interrupt.
 */
extern "C" void I2C3_ER_IRQHandler( void )
{
        HAL_I2C_ER_IRQHandler( &HANDLERS.i2c );
}

