require "math"

testing_poses = {4, 0.5, 4}
for i = 4, 20 do testing_poses[i] = math.random() * 4 end

for i, expected in ipairs(testing_poses) do
    msg {json = {"GOTO", expected, 1.}}

    for i = 1, 100 do
        coroutine.yield()
        os.execute("sleep 0.01")
    end
    pos = msg{json = {"POSITION"}}[2]
    assert(math.abs(pos - expected) < 0.2,
           "GOTO is not within tolerable range at the end time, actual: " .. pos ..
               " expected: " .. expected .. " tolerance: 0.2")

    for i = 1, 50 do
        coroutine.yield()
        os.execute("sleep 0.01")
    end
    pos = msg{json = {"POSITION"}}[2]
    assert(math.abs(pos - expected) < 0.05,
           "GOTO didn't finished in desired pos, actual: " .. pos ..
               " expected: " .. expected);
end
