#include "test/servo_runner.h"

#include <gtest/gtest.h>

using namespace schpin;

class ServoTestFixture : public testing::Test
{
public:
};

class ServoTest : public ServoTestFixture
{
public:
        explicit ServoTest( std::filesystem::path sc )
          : script( sc )
        {
        }

        void TestBody() override
        {
                servo_tester_config conf{
                    .type       = LEWAN_TEST,
                    .opt_id     = servo_id{ 1 },
                    .opt_dev    = std::optional< std::filesystem::path >{},
                    .opt_source = std::optional< std::filesystem::path >{} };

                servo_runner runner{ conf };

                runner.run_file( script );
        }

        std::filesystem::path script;
};

int main( int argc_in, char** argv_in )
{
        testing::InitGoogleTest( &argc_in, argv_in );

        std::vector< std::filesystem::path > paths = { "test/servo/random_goto.lua" };

        for ( std::filesystem::path p : paths ) {
                testing::RegisterTest(
                    "ServoTestFixture",
                    p.c_str(),
                    nullptr,
                    p.c_str(),
                    __FILE__,
                    __LINE__,
                    [=]() -> ServoTestFixture* {
                            return new ServoTest{ p };
                    } );
        }

        return RUN_ALL_TESTS();
}
